package top.daxian1218.dust.commons.generic;

import org.apache.commons.lang3.StringUtils;
import top.daxian1218.dust.commons.exception.DustException;
import top.daxian1218.dust.commons.exception.DustSystemException;

/**
 * @author hst
 */
public class Preconditions {
    public static void checkNotNull(Object obj) {
        if (obj == null) {
            throw new DustSystemException("对象不允许为null");
        }
    }

    public static void checkNotEmpty(String str) {
        if (StringUtils.isEmpty(str)) {
            throw new DustSystemException("字符串不允许为空");
        }
    }

    public static void checkNotEmpty(String str, String msg) {
        if (StringUtils.isEmpty(str)) {
            throw new DustSystemException(msg);
        }
    }

    public static void checkNotNull(Object obj, String msg) {
        if (obj == null) {
            throw new DustSystemException(msg);
        }
    }

    public static void checkRequired(Object obj, String name) {
        if (obj == null) {
            throw new DustSystemException("参数" + name + "为必填");
        }

        if (obj instanceof String && StringUtils.isEmpty((String)obj)) {
            throw new DustSystemException("参数" + name + "为必填");
        }
    }


}
