/**
 * everything will be ok
 *
 * @author : huangxianhui
 * @Version :
 * @Date : 2015年11月18日 下午8:07:31
 */
package top.daxian1218.dust.commons.util;

import org.apache.commons.lang3.StringUtils;

import java.io.ByteArrayOutputStream;
import java.io.UnsupportedEncodingException;
import java.nio.charset.Charset;
import java.nio.charset.StandardCharsets;
import java.util.*;

public class Base64Util {
        private static char[] base64EncodeChars = new char[]{'a', '2', 'C', '4', 'E', 'F', 'G', 'H', 'I', 'J', 'K', 'L', 'M', 'N', 'O', 'P', 'o', 'p',
                // 40, 41, 42, 43, 44, 45, 46, 47,
                'q', 'r', 's', 't', 'u', 'v',
                'Y', 'z', 'A', 'b', 'c', 'd', 'e', 'f', 'g', 'h', 'i', 'j', 'k', 'l', 'm', 'n', 'Q', 'R', 'S', 'T', 'U', 'V', 'W', 'X',
                // 16,
                // 17,
                // 18,
                // 19,
                // 20,
                // 21,
                // 22,
                // 23,
                'w', 'y', 'x', 'Z', '0', '1', 'B', '3', 'D', '8', '6', '7', '5', '9', '+', '/'};

        private static byte[] base64DecodeChars = new byte[]{-1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1,
                -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, 62, -1, -1, -1, 63,
                // +
                // /
                // 0-9
                52, 53, 1, 55, 3, 60, 58, 59, 57, 61,
                // A-Z
                -1, -1, -1, -1, -1, -1, -1, 26, 54, 2, 56, 4, 5, 6, 7, 8, 9, 10, 11, 12, 13, 14, 15, 40, 41, 42, 43, 44, 45, 46, 47, 24, 51,
                // a-z
                -1, -1, -1, -1, -1, -1, 0, 27, 28, 29, 30, 31, 32, 33, 34, 35, 36, 37, 38, 39, 16, 17, 18, 19, 20, 21, 22, 23, 48, 50, 49, 25,
                -1, -1, -1, -1, -1};

        /**
         * 自定义的Base64编码
         */
        public static String encodeEx(String str) {
            byte[] data = str.getBytes(StandardCharsets.UTF_8);
            StringBuilder sb = new StringBuilder();
            int len = data.length;
            int i = 0;
            int b1, b2, b3;

            while (i < len) {
                b1 = data[i++] & 0xff;
                // MOD 3 = 2添加两个“=”
                if (i == len) {
                    sb.append(base64EncodeChars[b1 >>> 2]);
                    sb.append(base64EncodeChars[(b1 & 0x3) << 4]);
                    sb.append("==");
                    break;
                }
                b2 = data[i++] & 0xff;
                // MOD 3 = 1添加一个“=”
                if (i == len) {
                    sb.append(base64EncodeChars[b1 >>> 2]);
                    sb.append(base64EncodeChars[((b1 & 0x03) << 4) | ((b2 & 0xf0) >>> 4)]);
                    sb.append(base64EncodeChars[(b2 & 0x0f) << 2]);
                    sb.append("=");
                    break;
                }

                b3 = data[i++] & 0xff;
                // 将3个字节变为四个字节，从表中替换相应的字符
                sb.append(base64EncodeChars[b1 >>> 2]);
                sb.append(base64EncodeChars[((b1 & 0x03) << 4) | ((b2 & 0xf0) >>> 4)]);
                sb.append(base64EncodeChars[((b2 & 0x0f) << 2) | ((b3 & 0xc0) >>> 6)]);
                sb.append(base64EncodeChars[b3 & 0x3f]);
            }
            return sb.toString();
        }

        /**
         * 自定义的Bas64解码
         * @param str
         * @return
         */
        public static String decodeEx(String str) {
            byte[] data = str.getBytes(StandardCharsets.UTF_8);
            for (int i = 0; i < data.length; i++) {
                if (data[i] == ' ') {
                    data[i] = '+';
                }
            }
            int len = data.length;
            ByteArrayOutputStream buf = new ByteArrayOutputStream(len);
            int i = 0;
            int b1, b2, b3, b4;

            while (i < len) {

                /* b1 */
                do {
                    b1 = base64DecodeChars[data[i++]];
                } while (i < len && b1 == -1);
                if (b1 == -1) {
                    break;
                }

                /* b2 */
                do {
                    b2 = base64DecodeChars[data[i++]];
                } while (i < len && b2 == -1);
                if (b2 == -1) {
                    break;
                }
                buf.write((b1 << 2) | ((b2 & 0x30) >>> 4));

                /* b3 */
                do {
                    b3 = data[i++];
                    if (b3 == 61) {
                        return new String(buf.toByteArray(), StandardCharsets.UTF_8);
                    }
                    b3 = base64DecodeChars[b3];
                } while (i < len && b3 == -1);
                if (b3 == -1) {
                    break;
                }
                buf.write(((b2 & 0x0f) << 4) | ((b3 & 0x3c) >>> 2));

                /* b4 */
                do {
                    b4 = data[i++];
                    // 遇到“=”不需要处理
                    if (b4 == 61) {
                        return new String(buf.toByteArray(), StandardCharsets.UTF_8);
                    }
                    b4 = base64DecodeChars[b4];
                } while (i < len && b4 == -1);
                if (b4 == -1) {
                    break;
                }
                buf.write(((b3 & 0x03) << 6) | b4);
            }
            /*
             * if(Util.getCheck()==0){ return new String(buf.toByteArray()); } else{
             * return null; }
             */
            return new String(buf.toByteArray(), StandardCharsets.UTF_8);
        }

        /**
         * 通用BASE64编码，基于UTF-8
         * @param content
         * @return
         */
        public static String encode(String content) {
            if (StringUtils.isEmpty(content)) { return StringUtils.EMPTY; }
            return Base64.getEncoder().encodeToString(content.getBytes(StandardCharsets.UTF_8));
        }

        public static String encodeOfBytes(byte[] data) {
            if (data == null || data.length == 0) { return StringUtils.EMPTY; }
            return Base64.getEncoder().encodeToString(data);
        }

        /**
         * 通用BASE64解码，基于UTF-8
         * @param content
         * @return
         */
        public static String decode(String content) {
            if (StringUtils.isEmpty(content)) { return StringUtils.EMPTY; }
            return new String(Base64.getDecoder().decode(content.getBytes(StandardCharsets.UTF_8)), StandardCharsets.UTF_8);
        }

        public static byte[] decodeToBytes(String content) {
            if (StringUtils.isEmpty(content)) { return new byte[0]; }
            return Base64.getDecoder().decode(content.getBytes(StandardCharsets.UTF_8));
        }
}
