package top.daxian1218.dust.commons.util;

import java.io.IOException;
import java.io.InputStream;
import java.util.Properties;

/**
 * 属性帮助类
 * @author hst
 */
public class PropUtil {

    private static Properties loadProperties(InputStream is) throws IOException {
        Properties properties = new Properties();
        properties.load(is);
        return properties;
    }

    private static Properties loadPropertiesFromXml(InputStream is) throws IOException {
        Properties properties = new Properties();
        properties.loadFromXML(is);
        return properties;
    }

    public static String getProperty(String pathToConfig, String key) {
        try {
            InputStream is = ClassLoader.getSystemResourceAsStream(pathToConfig);
            if (is != null) {
                Properties properties = loadProperties(is);
                return properties.getProperty(key);
            }

        } catch (Exception ex) {
        }
        return "";
    }

    public static String getProperty(Class c, String pathToConfig, String key) {
        try {
            InputStream is = c.getResourceAsStream(pathToConfig);
            if (is != null) {
                Properties properties = loadProperties(is);
                return properties.getProperty(key);
            }

        } catch (Exception ex) {
        }
        return "";
    }

    public static String getPropertyFromXml(Class c, String pathToConfig, String key) {
        try {
            InputStream is = c.getResourceAsStream(pathToConfig);
            if (is != null) {
                Properties properties = loadPropertiesFromXml(is);
                return properties.getProperty(key);
            }

        } catch (Exception ex) {
            ex.printStackTrace();
        }
        return "";
    }
}
